unit FRB;

interface

type PSingle=^Single;
     PWord=^Word;
     PInteger=^Integer;

Const

 FRB_NoError                = 0;
 FRB_DriverOpenError        = 1;
 FRB_DriverNoOpen           = 2;
 FRB_GetDriverVersionError  = 3;
 FRB_FindBoardError         = 4;
 FRB_ExceedBoardNumber	    = 5;
 FRB_InputParameterError    = 6;



// Function of Test
Function  FRB_GetDllVersion:WORD; StdCall;
Function  FRB_GetDriverVersion(var wDriverVersion:WORD):Word; StdCall;

// Function of DI/DO
Function  FRB_SendSA(wPort:WORD;SAn:WORD;wOutputData:WORD):Word; StdCall;
Function  FRB_ReceiveRA(wPort:WORD;RAn:WORD;var wInputData:Word):Word; StdCall;
Function  FRB_ReadRAStatus(wPort:WORD;var bRAStatus:BYTE):Word; StdCall;

// Function of Driver	
Function  FRB_DriverInit(var wTotalBoard:WORD):WORD; StdCall;
Procedure FRB_DriverClose; StdCall;
Function  FRB_ActiveBoard(wBoardNo:WORD):WORD; StdCall;
Function  FRB_GetConfigAddressSpace(wBoardNo:WORD; var wAddrBase:Longword; var wIrqNo:WORD;var wSubVendor:WORD; var wSubDevice:WORD; var wSubAux:WORD;var wSlotBus:WORD; var wSlotDevice:WORD):WORD; StdCall;

// Function of DI/DO for Board number
Function  FRB_SendSABoard(wBoardNo:WORD;wPort:WORD;SAn:WORD;wOutputData:WORD):Word; StdCall;
Function  FRB_ReceiveRABoard(wBoardNo:WORD;wPort:WORD;RAn:WORD;var wInputData:Word):Word; StdCall;
Function  FRB_ReadRAStatusBoard(wBoardNo:WORD;wPort:WORD;var bRAStatus:BYTE):Word; StdCall;


implementation

Function  FRB_GetDllVersion;     	external 'FRB.DLL' name 'FRB_GetDllVersion';
Function  FRB_GetDriverVersion;   	external 'FRB.DLL' name 'FRB_GetDriverVersion';

Function  FRB_SendSA;          		external 'FRB.DLL' name 'FRB_SendSA';
Function  FRB_ReceiveRA;           	external 'FRB.DLL' name 'FRB_ReceiveRA';
Function  FRB_ReadRAStatus;           	external 'FRB.DLL' name 'FRB_ReadRAStatus';
 
Function  FRB_DriverInit;         	external 'FRB.DLL' name 'FRB_DriverInit';
Procedure FRB_DriverClose;        	external 'FRB.DLL' name 'FRB_DriverClose';
Function  FRB_ActiveBoard;       	external 'FRB.DLL' name 'FRB_ActiveBoard';
Function  FRB_GetConfigAddressSpace;    external 'FRB.DLL' name 'FRB_GetConfigAddressSpace';

// BoardNo select
Function  FRB_SendSABoard;          	external 'FRB.DLL' name 'FRB_SendSABoard';
Function  FRB_ReceiveRABoard;           external 'FRB.DLL' name 'FRB_ReceiveRABoard';
Function  FRB_ReadRAStatusBoard;        external 'FRB.DLL' name 'FRB_ReadRAStatusBoard';

end.

