
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    Label3: TLabel;
    Label4: TLabel;
    Shape1: TShape;
    spIn00: TShape;
    Shape3: TShape;
    spIn01: TShape;
    Shape5: TShape;
    spIn02: TShape;
    Shape7: TShape;
    spIn03: TShape;
    Shape9: TShape;
    spIn04: TShape;
    Shape11: TShape;
    spIn05: TShape;
    Shape13: TShape;
    spIn06: TShape;
    Shape15: TShape;
    spIn07: TShape;
    Shape17: TShape;
    spIn08: TShape;
    Shape19: TShape;
    spIn09: TShape;
    Shape21: TShape;
    spIn0A: TShape;
    Shape23: TShape;
    spIn0B: TShape;
    Shape25: TShape;
    spIn0C: TShape;
    Shape27: TShape;
    spIn0D: TShape;
    Shape29: TShape;
    spIn0E: TShape;
    Shape31: TShape;
    spIn0F: TShape;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox4: TGroupBox;
    Label1: TLabel;
    Label8: TLabel;
    eTotal: TEdit;
    eSelect: TEdit;
    ePort: TComboBox;
    Port: TLabel;
    Label7: TLabel;
    eSA: TComboBox;
    eRA: TComboBox;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CheckBox1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ePortClick(Sender: TObject);
    procedure eSAClick(Sender: TObject);
    procedure eRAChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses FRB;

{$R *.DFM}

Var
   wInitialCode, wTotalBoards,wPort,wSAn,wRAn : Word;
   wDoVal,wRtn : Word;
   wBoardNo : Word;

procedure TForm1.Button1Click(Sender: TObject);
begin
    If Button1.Caption = 'Active' Then
    begin
        wBoardNo:=StrToInt(eSelect.Text);

        CheckBox1Click( CheckBox1 );
        CheckBox1Click( CheckBox1 );
        Button1.Caption   := 'Stop';
        Timer1.Enabled    := True;
        Button2.Enabled   := False;
        Groupbox1.Enabled := True;
        ePort.Enabled     := False;
        eSA.Enabled       := False;
        eRA.Enabled       := False;
    end
    Else
    begin
        Button1.Caption   := 'Active';
        Timer1.Enabled    := False;
        Button2.Enabled   := True;
        Groupbox1.Enabled := False;
        ePort.Enabled     := True;
        eSA.Enabled       := True;
        eRA.Enabled       := True;
    End;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Button1.Caption := 'Active';
    Button1.Enabled := False;
    wInitialCode := FRB_DriverInit( wTotalBoards );
    If wInitialCode <> FRB_NoError Then
    begin
        ShowMessage( 'Device driver Open Error!!');
        exit;
    end;

    eTotal.Text := IntToStr( wTotalBoards );
    if wTotalBoards < 1 then
    begin
        ShowMessage( 'Card Not Found!!' );
        exit;
    end;
    wPort :=StrToInt(ePort.Text);
    wSAn := StrToInt(eSA.Text);
    wRAn := StrToInt(eRA.Text);
    Button1.Enabled := True;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Timer1.Enabled := False;
     FRB_DriverClose();
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
    if (Sender As TCheckBox).Checked then
       wDoVal := wDoVal or (1 shl (Sender As TCheckBox).Tag)
    else
        wDoVal := wDoVal and (Not(1 shl (Sender As TCheckBox).Tag));
    wRtn := FRB_SendSABoard(wBoardNo, wPort,wSAn,wDoVal) ;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
Var
    i :integer;
    wDiVal : Word;

begin

   wRtn := FRB_ReceiveRABoard(wBoardNo, wPort, wRAn, wDiVal);
    For I := 0 To 15 do
        if ( wDiVal and (1 shl i)) <> 0 then
            (FindComponent('spIn' + IntToHex(i,2) ) As TShape).Brush.Color := clRed
        else
            (FindComponent('spIn' + IntToHex(i,2) ) As TShape).Brush.Color := clBlack;
end;



procedure TForm1.ePortClick(Sender: TObject);
begin
  wPort :=StrToInt(ePort.Text);
end;

procedure TForm1.eSAClick(Sender: TObject);
begin
  wSAn :=StrToInt(eSA.Text);
end;

procedure TForm1.eRAChange(Sender: TObject);
begin
  wRAn :=StrToInt(eRA.Text);
end;

end.
